const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const bodyTemperatureService = require('./bodyTemperature.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new bodyTemperature
 * @param {Object} req.body - The bodyTemperature data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created bodyTemperature
 */
function create(req, res, next) {
    bodyTemperatureService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all bodyTemperatures
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of bodyTemperatures
 */
function getAll(req, res, next) {
    bodyTemperatureService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of bodyTemperature objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of bodyTemperature objects
 */
function option(req, res, next) {
    bodyTemperatureService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of bodyTemperatures matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of bodyTemperatures
 */
function count(req, res, next) {
    bodyTemperatureService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing bodyTemperature
 * @param {number} req.params.id - The bodyTemperature ID to be updated
 * @param {Object} req.body - The bodyTemperature data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated bodyTemperature
 */
function update(req, res, next) {
    bodyTemperatureService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Enable or disable a bodyTemperature
 * @param {number} req.params.id - The bodyTemperature ID to be enabled/disabled
 * @param {Object} req.body - The bodyTemperature data to be updated
 * @param {boolean} req.body.enabled - The enabled status of the bodyTemperature
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the enable/disable process
 */
function enabled(req, res, next) {
    bodyTemperatureService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a bodyTemperature
 * @param {number} req.params.id - The bodyTemperature ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    bodyTemperatureService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
